// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: scenarioAction.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ScenarioActionClient is the client API for ScenarioAction service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ScenarioActionClient interface {
	Create(ctx context.Context, in *ScenarioActionModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *ScenarioActionModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	BatchUpdate(ctx context.Context, in *ScenarioActionBatch, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioActionModel, error)
	List(ctx context.Context, in *ScenarioActionReq, opts ...grpc.CallOption) (ScenarioAction_ListClient, error)
}

type scenarioActionClient struct {
	cc grpc.ClientConnInterface
}

func NewScenarioActionClient(cc grpc.ClientConnInterface) ScenarioActionClient {
	return &scenarioActionClient{cc}
}

func (c *scenarioActionClient) Create(ctx context.Context, in *ScenarioActionModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioAction/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioActionClient) Update(ctx context.Context, in *ScenarioActionModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioAction/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioActionClient) BatchUpdate(ctx context.Context, in *ScenarioActionBatch, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioAction/BatchUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioActionClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioAction/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioActionClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioActionModel, error) {
	out := new(ScenarioActionModel)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioAction/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioActionClient) List(ctx context.Context, in *ScenarioActionReq, opts ...grpc.CallOption) (ScenarioAction_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &ScenarioAction_ServiceDesc.Streams[0], "/botMs.ScenarioAction/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &scenarioActionListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type ScenarioAction_ListClient interface {
	Recv() (*ScenarioActionModel, error)
	grpc.ClientStream
}

type scenarioActionListClient struct {
	grpc.ClientStream
}

func (x *scenarioActionListClient) Recv() (*ScenarioActionModel, error) {
	m := new(ScenarioActionModel)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// ScenarioActionServer is the server API for ScenarioAction service.
// All implementations must embed UnimplementedScenarioActionServer
// for forward compatibility
type ScenarioActionServer interface {
	Create(context.Context, *ScenarioActionModel) (*proto.IdRequest, error)
	Update(context.Context, *ScenarioActionModel) (*emptypb.Empty, error)
	BatchUpdate(context.Context, *ScenarioActionBatch) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*ScenarioActionModel, error)
	List(*ScenarioActionReq, ScenarioAction_ListServer) error
	mustEmbedUnimplementedScenarioActionServer()
}

// UnimplementedScenarioActionServer must be embedded to have forward compatible implementations.
type UnimplementedScenarioActionServer struct {
}

func (UnimplementedScenarioActionServer) Create(context.Context, *ScenarioActionModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedScenarioActionServer) Update(context.Context, *ScenarioActionModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedScenarioActionServer) BatchUpdate(context.Context, *ScenarioActionBatch) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchUpdate not implemented")
}
func (UnimplementedScenarioActionServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedScenarioActionServer) Get(context.Context, *proto.IdRequest) (*ScenarioActionModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedScenarioActionServer) List(*ScenarioActionReq, ScenarioAction_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedScenarioActionServer) mustEmbedUnimplementedScenarioActionServer() {}

// UnsafeScenarioActionServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ScenarioActionServer will
// result in compilation errors.
type UnsafeScenarioActionServer interface {
	mustEmbedUnimplementedScenarioActionServer()
}

func RegisterScenarioActionServer(s grpc.ServiceRegistrar, srv ScenarioActionServer) {
	s.RegisterService(&ScenarioAction_ServiceDesc, srv)
}

func _ScenarioAction_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioActionModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioActionServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioAction/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioActionServer).Create(ctx, req.(*ScenarioActionModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioAction_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioActionModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioActionServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioAction/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioActionServer).Update(ctx, req.(*ScenarioActionModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioAction_BatchUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioActionBatch)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioActionServer).BatchUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioAction/BatchUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioActionServer).BatchUpdate(ctx, req.(*ScenarioActionBatch))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioAction_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioActionServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioAction/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioActionServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioAction_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioActionServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioAction/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioActionServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioAction_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(ScenarioActionReq)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ScenarioActionServer).List(m, &scenarioActionListServer{stream})
}

type ScenarioAction_ListServer interface {
	Send(*ScenarioActionModel) error
	grpc.ServerStream
}

type scenarioActionListServer struct {
	grpc.ServerStream
}

func (x *scenarioActionListServer) Send(m *ScenarioActionModel) error {
	return x.ServerStream.SendMsg(m)
}

// ScenarioAction_ServiceDesc is the grpc.ServiceDesc for ScenarioAction service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ScenarioAction_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.ScenarioAction",
	HandlerType: (*ScenarioActionServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _ScenarioAction_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _ScenarioAction_Update_Handler,
		},
		{
			MethodName: "BatchUpdate",
			Handler:    _ScenarioAction_BatchUpdate_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _ScenarioAction_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _ScenarioAction_Get_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _ScenarioAction_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "scenarioAction.proto",
}
